config/routes.rb
Rails.application.routes.draw do
  devise_for :users

  devise_scope :user do
    authenticated :user do
      root 'home#index', as: :authenticated_root
      get 'cities/search'
    end
  
    unauthenticated do
      root 'devise/sessions#new', as: :unauthenticated_root
    end
  end
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/city.rb
class City < ApplicationRecord
  has_many :search_records
  has_many :users, through: :search_records
end

app/models/search_record.rb
class SearchRecord < ApplicationRecord
  belongs_to :city
  belongs_to :user
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable,
         :confirmable, :trackable
  has_many :search_records
  has_many :cities, through: :search_records
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/cities_controller.rb
class CitiesController < ApplicationController
  before_action :force_json, only: :search

  def search
    searcher = SearchIataCities.new(city: params[:q])
    @cities = searcher.run
  end

  private

  def force_json
    request.format = :json
  end
end

app/controllers/home_controller.rb
class HomeController < ApplicationController
  def index
    searcher = SearchWeather.new(city: params[:city])
    @city = searcher.run
    SearchHistory.save(user: current_user, city: @city)
    @last_cities_found = SearchHistory.fetch(user: current_user)
  end
end
  

app/helpers/application_helper.rb
module ApplicationHelper
end

app/views/home/_search_form.html.slim
= form_with url: authenticated_root_path, method: :get, class: "search-form" do |f|
  .search-container
    = f.label :city, class: "hidden"
    = f.text_field :city, :value => "#{params[:city]}", "data-behavior":"autocomplete", placeholder: "Search a City", id:"search-field"
    = f.button nil, class: "search-button" do
      i.fa-solid.fa-magnifying-glass.text-lg

app/views/home/_search_latests.html.slim
- if @last_cities_found.present?
  - @last_cities_found.each do |city|
    button.searched-city
      = link_to city.name, {city: "#{city.name} - #{city.iata}"}

app/views/home/_search_result.html.slim
- if @city.present?
  .flex.items-center.gap-x-5
    div
      p.text-xl
        = image_tag @city.condition_icon
    div 
      h2.result__full-name
        = @city.full_name
      div
        = @city.time
      div
        = @city.time_offset
      div
        = @city.local_time
  .mt-5.mb-28.flex.items-center.justify-center
    .button-cover
      .button.b2.temp_switch
        input.checkbox(type="checkbox")
        .knobs
          span
            | °C
        .layer
        .result__temperature#celsius
          .text-8xl.leading-none.font-light
            = @city.celsius_temp
          .text-2xl
            | °C
        .result__temperature.hidden#fahrenheit
          .text-8xl.leading-none.font-light
            = @city.fahrenheit_temp
          .text-2xl
            | °F

        .capitalize.text-center
          = @city.condition
  
  = link_to "http://maps.google.com?q=#{@city.latitude},#{@city.longitude}", class: "result__location flex items-center" do
    i.fa-sharp.fa-solid.fa-location-dot
    div.ml-3
      .mt-4.result__latitude
        | lat: 
        = @city.latitude
      .mt-2.result__longitude
        | lon: 
        = @city.longitude
- else
  p.text-xl
      | Search a City

app/views/home/index.html.slim
.search
  header.p-2
    .search-nav
      .search-logo
        = link_to "Weather Dashboard", authenticated_root_path
      div.sign-out
        = link_to 'Sign out', destroy_user_session_path, :method=>'delete'
    div.mb-4
      = render "search_latests", last_cities_found: @last_cities_found
    nav.z-20.px-3
      = render "search_form"


  .search-result.min-h-lg
    = render "search_result", city: @city

app/views/layouts/_navigation_links.html.slim
- if user_signed_in?
  /li
    = link_to 'Edit account', edit_user_registration_path
  li
    = link_to 'Sign out', destroy_user_session_path, :method=>'delete'

app/views/layouts/application.html.slim
doctype html
html
  head
    title
      | WeatherApp
    meta[name="viewport" content="width=device-width,initial-scale=1"]
    = csrf_meta_tags
    = csp_meta_tag
    = stylesheet_link_tag "tailwind", "inter-font", "data-turbo-track": "reload"
    = stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload'
    = javascript_pack_tag 'application', 'data-turbolinks-track': 'reload'
  body
    main.container.mx-auto.px-5
      - if user_signed_in?
        = render 'shared/flash'
        = yield
      - else
        section.auth-layout
          .auth-container.flex
            .auth-section
              = yield
            .wallpaper-section
              = image_tag "login.jpg", alt: "Login Wallpaper", class: "rounded-2xl"

app/views/shared/_flash.html.slim
- flash.each do | key,value|
  = content_tag :div, value, class: key